import { StaggerConfig, HandleEnterUpdateDelete } from './Flipper/types';
import { FlippedProps } from './Flipped/types';
import { SpringOption } from './springSettings/types';
declare class Flipper {
    private element;
    private staggerConfig;
    private applyTransformOrigin;
    private handleEnterUpdateDelete;
    private debug;
    private spring;
    private inProgressAnimations;
    private flipCallbacks;
    private snapshot;
    constructor(options: {
        element: HTMLElement;
        staggerConfig: StaggerConfig;
        spring: SpringOption;
        applyTransformOrigin: boolean;
        handleEnterUpdateDelete: HandleEnterUpdateDelete;
        debug: boolean;
    });
    recordBeforeUpdate(): void;
    onUpdate(): void;
    addFlipped({ element, flipId, opacity, translate, scale, transformOrigin, spring, stagger, onAppear, onStart, onComplete, onExit, shouldFlip }: FlippedProps & {
        element: HTMLElement;
    }): void;
    addInverted({ element, parent, opacity, translate, scale, transformOrigin }: {
        element: HTMLElement;
        parent: HTMLElement;
        opacity: boolean;
        translate: boolean;
        scale: boolean;
        transformOrigin: string;
    }): void;
}
export default Flipper;
